package lucastest;

public class Lineage {
    int idx;
    int sib;
    double startT;
    double endT;
    int startB;
    int endB;

    Lineage(GTree gTree, int i) {
        idx = i;
        GNode node = gTree.getNode(i);
        startT = node.getHeight();
        startB = node.getSTip(); // only for no-merges
        int anc = node.getAnc();
        GNode ancNode = gTree.getNode(anc);
        endT = ancNode.getHeight();
        endB = ancNode.getSTip();
        if (ancNode.getChX() == i) {
            sib = ancNode.getChY();
        } else {
            sib = ancNode.getChX();
        }
    }

    public String asText() {
        return String.format("idx %2d sib %2d start %s %2d end %s %2d", idx, sib, Utils.nonNegIn8Chars(startT), startB, Utils.nonNegIn8Chars(endT), endB);
    }

}
