package lucastest;

public class Utils {


    public static String nonNegIn8Chars(double x) {
        String s = "";
        if (x < 0) {
            s = String.format("%8s", "NA");
        } else if (x == 0.0) {
            s = String.format("%8s", "zero");
        } else if (x < 1e-3) {
            s = String.format("%8.2e", x);
        } else if (x < 9.999) {
            s = String.format("%8.5f", x);
        } else if (x < 99.99) {
            s = String.format("%8.4f", x);
        } else if (x < 999.9) {
            s = String.format("%8.3f", x);
        } else if (x < 9999) {
            s = String.format("%8.2f", x);
        } else {
            s = String.format("%8.0f", x);
        }
        return s;
    }


    public static String doubleIn9Chars(double x) {
        assert Double.isFinite(x);
        String s = " ";
        double y = Math.abs(x);
        if (y == 0.0) {
            s += "   zero ";
        } else if (y < 1e-3) {
            s += String.format("%8.2e", x);
        } else if (y < 9.999) {
            s += String.format("%8.5f", x);
        } else if (y < 99.99) {
            s += String.format("%8.4f", x);
        } else if (y < 999.9) {
            s += String.format("%8.3f", x);
        } else if (y < 9999) {
            s += String.format("%8.2f", x);
        } else {
            s += String.format("%8.0f", x);
        }
        return s;
    }


    public static double oneMinusExpMinusX(double x) {
        return -Math.expm1(-x);
    }


    public static double uexp(double x) {
        double y = 1.0;
        if (x >  1e-8) {
            y = (-Math.expm1(-x) / (x));
        }
        return y;
    }


    public static boolean validProbability(double p) {
        assert Double.isFinite(p);
        return p >= 0.0  && p <= 1.0;
    }


    public static boolean floatsVClose(double x, double y) {
        assert Double.isFinite(x);
        assert Double.isFinite(y);
        double z = Math.abs(x) + Math.abs(y);
        return Math.abs(x-y) <= z * 1e-12;
    }

}
